package spider;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.*;

import org.junit.Test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.utils.ApiUtil;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.CharsetUtil;
import cn.hutool.db.DbUtil;
import cn.hutool.db.Entity;

public class CollegeData {
    private static String host = "https://apiv4.diyigaokao.com";

    private List<String> errors = new ArrayList<>();

    @Test
    public void test() throws Exception {
        // 湖南
        ApiUtil.getInstance().login();
        collegeList();
//        getCategoryMajor();
//        generateNineDate();
//         广东账号：18774924158，密码：123456
//         ApiUtil.getInstance().login("18774924158", "123456",false);
        // 湖北账号：18674898114， 密码：123456
        // ApiUtil.getInstance().login("18674898114", "123456",false);
        // 江西账号：13203226079，密码：123456
//        ApiUtil.getInstance().login("13203226079", "123456",false);
//        collegeList();
        // getCategoryMajor();
    }

    public void collegeList() throws SQLException {
        int count = 0, total = 5000, page = 1;
        do {
            try {
                StringBuilder sb = new StringBuilder(host);
                sb.append("/college/list/byMultiple");
                sb.append("?provinceIds=&yxjbz=&levels=&collegeType=&hotTags=");
                sb.append("&pageIndex=").append(page).append("&pageSize=15");
                JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
                total = res.getInteger("total");
                JSONArray data = res.getJSONArray("data");
                for (int i = 0; i < data.size(); i++) {
                    long start = System.currentTimeMillis();
                    JSONObject row = data.getJSONObject(i);
                    final Integer collegeId = row.getInteger("id");
                    Entity entity = DbUtil.use().get("college", "id", collegeId);
                    if (null == entity) {
//                        detail(collegeId, 0);
                        ThreadUtil.safeSleep(1 * 1000);
                    }
                    //选科数据
                    xuanke(collegeId);
                    ThreadUtil.safeSleep(1 * 1000);
                    System.out.println(DateUtil.formatBetween(System.currentTimeMillis() - start));
                }
                System.out.println("已完成:" + page);
                count = page * 15;
                page += 1;
            } catch (IOException e) {
                e.printStackTrace();
            }
        } while (count <= total);
        File dir = new File("E:/projects/wangmin/evaluation/code/spider/");
        FileUtil.writeLines(errors, new File(dir, ApiUtil.getInstance().getUser().getCode() + ".txt"), CharsetUtil.CHARSET_UTF_8);
        System.out.println("执行完成!");
    }

    private void detail(Integer id, Integer retry) {
        int maxRetry = 2;
        JSONObject res = null;
        try {
            String url = host + "/college/detail/" + id;
            res = ApiUtil.getInstance().httpSyncGet(url);
            if (Integer.valueOf(-1).equals(res.getInteger("error"))) {
                System.out.println(url);
                if (retry >= maxRetry) {
                    System.out.println("重试" + maxRetry + "次还不够:" + id);
                    errors.add(url + "\t" + res.getString("data"));
                    return;
                }
                ThreadUtil.safeSleep(1 * 1000);
                detail(id, retry + 1);
            } else {
                JSONObject data = res.getJSONObject("data");
                data.remove("rankMap");
                data.remove("collegeDetailHotMajor");
                data.remove("yuanxiList");
                Entity record = Entity.create("college");
                record.putAll(data);
                DbUtil.use().insertOrUpdate(record, "id");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }

    private void xuanke(Integer collegeId) {
        List<Integer> years = new ArrayList<Integer>(2);
        Integer provinceId = ApiUtil.getInstance().getUser().getProvinceId();
        try {
            JSONObject res = ApiUtil.getInstance().httpSyncGet(host + "/years?provinceId=" + provinceId + "&queryType=4");
            JSONArray rows = res.getJSONArray("data");
            for (int i = 0; i < rows.size(); i++) {
                years.add(rows.getJSONObject(i).getInteger("year"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        List<Entity> records = new ArrayList<>(12);
        for (Integer year : years) {
            int count = 0, total = 100, page = 1;
            do {
                try {
                    StringBuilder sb = new StringBuilder();
                    sb.append(host).append("/xuanke/list/byCollegeId");
                    sb.append("?provinceId=").append(provinceId);
                    sb.append("&collegeId=").append(collegeId);
                    sb.append("&year=").append(year);
                    sb.append("&page=").append(page).append("&pageSize=30");
                    JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
                    JSONArray rows = res.getJSONArray("data");
                    for (int i = 0; i < rows.size(); i++) {
                        JSONObject row = rows.getJSONObject(i);
                        row.remove("Row");
                        Entity record = Entity.create("major");
                        record.putAll(row);
                        record.set("_provinceId", provinceId).set("_collegeId", collegeId).set("_year", year);
                        records.add(record);
                    }
                    total = res.getInteger("total");
                    count = page * 30;
                    page += 1;
                } catch (Exception e) {
                    e.printStackTrace();
                }

            } while (count <= total);
        }
        try {
            DbUtil.use().del(Entity.create("major").set("CollegeID", collegeId));
            DbUtil.use().insert(records);
            // DbUtil.use()
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 获取专业列表
     */
    public void getCategoryMajor() {
        Set<Entity> MajorSubjectList = new HashSet<>();// 一级专业
        Set<Entity> MajorCategoryList = new HashSet<Entity>();// 二级专业
        Set<Entity> MajorList = new HashSet<Entity>();// 三级专业
        try {
            JSONObject res = ApiUtil.getInstance().httpSyncGet(host + "/major/allCategoryMajor");
            JSONObject data = res.getJSONObject("data");
            // JSONArray bk = data.getJSONArray("BK");
            JSONArray zk = data.getJSONArray("ZK");
            // getData(bk,"本科",MajorSubjectList,MajorCategoryList,MajorList);
            MajorSubjectList.clear();// 一级专业
            MajorCategoryList.clear();// 二级专业
            MajorList.clear();// 三级专业
            getData(zk, "专科", MajorSubjectList, MajorCategoryList, MajorList);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void getData(JSONArray bk, String Type, Set<Entity> MajorSubjectList, Set<Entity> MajorCategoryList, Set<Entity> MajorList) {
        for (int i = 0; i < bk.size(); i++) {
            JSONObject Subject = bk.getJSONObject(i);
            if ("专科".equalsIgnoreCase(Type)) {
                // 专科的ID在本科的基础上增加12
                Subject.put("ID", (Subject.getInteger("ID") + 12));
            }
            Subject.put("Type", Type);
            JSONArray CategoryArray = Subject.getJSONArray("Category");
            Subject.remove("Category");
            Entity subjectTable = Entity.create("sy_major_subject");
            subjectTable.putAll(Subject);

            MajorSubjectList.add(subjectTable);
            System.out.println(Type + "：MajorSubjectList：" + JSONObject.toJSONString(MajorSubjectList));

            for (int j = 0; j < CategoryArray.size(); j++) {
                JSONObject Category = CategoryArray.getJSONObject(j);
                Category.put("MajorSubjectCode", Subject.getString("SubjectCode"));// 上级ID填充下级
                Category.remove("MajorSubjectID");// ID转换为code作为关联

                Category.put("Type", Type);
                if ("专科".equalsIgnoreCase(Type)) {
                    Category.remove("ID");
                }

                // System.out.println("before Category："+Category);
                JSONArray MajorArray = Category.getJSONArray("Major");

                Category.remove("Major");
                // System.out.println("after Category："+Category);

                Entity categoryTable = Entity.create("sy_major_category");
                categoryTable.putAll(Category);
                MajorCategoryList.add(categoryTable);
                for (int k = 0; k < MajorArray.size(); k++) {
                    JSONObject Major = MajorArray.getJSONObject(k);
                    Major.put("MajorCategoryCode", Category.getString("MajorCategoryCode"));// 上级ID填充下级
                    Major.remove("MajorCategoryID");// ID转换为code关联
                    Major.put("Type", Type);
                    if ("专科".equalsIgnoreCase(Type)) {
                        Major.remove("ID");
                    }

                    Entity majorTable = Entity.create("sy_major_major");
                    majorTable.putAll(Major);
                    MajorList.add(majorTable);
                }
            }

            try {
                // DbUtil.use().del(Entity.create("sy_major_subject").set("Type", Type));
                DbUtil.use().insert(MajorSubjectList);
                MajorSubjectList.clear();

                // DbUtil.use().del(Entity.create("sy_major_category").set("Type", Type));
                DbUtil.use().insert(MajorCategoryList);
                MajorCategoryList.clear();

                // DbUtil.use().del(Entity.create("sy_major_major").set("Type", Type));
                DbUtil.use().insert(MajorList);
                MajorList.clear();

            } catch (Exception e) {
                e.printStackTrace();
            }

        }
    }

    /**
     * 随机生成9科数据
     */
    private void generateNineDate(){
        int count = 6000;
//        JSONArray majorArray = new JSONArray();
        Set<Entity> MajorList = new HashSet<Entity>();
        for (int i =0 ;i<count;i++){
            Map major=new TreeMap();
            major.put("chinese",(int)(100-Math.random()*50));
            major.put("math",(int)(100-Math.random()*50));
            major.put("english",(int)(100-Math.random()*50));
            major.put("physics",(int)(100-Math.random()*50));
            major.put("chemistry",(int)(100-Math.random()*50));
            major.put("biology",(int)(100-Math.random()*50));
            major.put("history",(int)(100-Math.random()*50));
            major.put("politics",(int)(100-Math.random()*50));
            major.put("geography",(int)(100-Math.random()*50));

            Entity majorTable = Entity.create("major_nine");
            majorTable.putAll(major);
            MajorList.add(majorTable);

//            System.out.println(major);
        }


        try {
            DbUtil.use().insert(MajorList);
        } catch (SQLException e) {
            e.printStackTrace();
        }

        System.out.println("finished");

    }
}
